reports retcod from run_log
[build.git] / lbuild-nightly.sh
index bf79807..6814859 100755 (executable)
@@ -1,21 +1,18 @@
 #!/bin/bash
 
-# NOTE on lxcsu
-# this tool derives from the PL code, from the lxc-userspace module
-# can be obtained through rpm/yum
-# it is used here as a replacement for 'vserver <> exec'
-# that is used throughout this code
-
 COMMANDPATH=$0
 COMMAND=$(basename $0)
 
+# old guests have e.g. mount in /bin but this is no longer part of 
+# the standard PATH in recent hosts after usrmove, so let's keep it simple
+export PATH=$PATH:/bin:/sbin
+
 # default values, tunable with command-line options
 DEFAULT_FCDISTRO=f20
 DEFAULT_PLDISTRO=planetlab
 DEFAULT_PERSONALITY=linux64
 DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
-DEFAULT_IFNAME=eth0
 
 # default gpg path used in signing yum repo
 DEFAULT_GPGPATH="/etc/planetlab"
@@ -47,13 +44,15 @@ fi
 ####################
 # assuming vm runs in UTC
 DATE=$(date +'%Y.%m.%d')
+BUILD_BEG=$(date +'%H:%M')
+BUILD_BEG_S=$(date +'%s')
 
 # still using /vservers for legacy reasons
 # as far as the build & test infra, we could adopt a new name
 # but the PL code still uses this name for now, so let's keep it simple
 function rootdir () {
     slice=$1; shift
-    echo /vservers/$slice/rootfs
+    echo /vservers/$slice
 }
 function logfile () {
     slice=$1; shift
@@ -140,6 +139,17 @@ function webpublish_rsync_files () {
     rsync --archive $VERBOSE "$@" root@${WEBHOST}:"$remote" ;
 }
 
+function pretty_duration () {
+    total_seconds=$1; shift
+
+    seconds=$(($total_seconds%60))
+    total_minutes=$(($total_seconds/60))
+    minutes=$(($total_minutes%60))
+    hours=$(($total_minutes/60))
+    
+    printf "%02d:%02d:%02d" $hours $minutes $seconds
+}
+
 # Notify recipient of failure or success, manage various stamps 
 function failure() {
     set -x
@@ -183,12 +193,15 @@ function success () {
     summary $LOG | webpublish_append_stdin_to_file $WEBLOG
     if [ -n "$DO_TEST" ] ; then
        short_message="PASS"
+       ext="pass"
+       if [ -n "$IGNORED" ] ; then short_message="PASS/WARN"; ext="warn"; fi
        ( \
            echo "Successfully built and tested" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
            echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
-           ) | webpublish_cp_stdin_to_file $WEBBASE.pass
+           [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
+           ) | webpublish_cp_stdin_to_file $WEBBASE.$ext
        webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
     else
        short_message="PKGOK"
@@ -199,6 +212,8 @@ function success () {
            ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
        webpublish rm -f $WEBBASE.ko
     fi
+    BUILD_END=$(date +'%H:%M')
+    BUILD_END_S=$(date +'%s')
     if [ -n "$MAILTO" ] ; then
        ( \
            echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
@@ -206,8 +221,10 @@ function success () {
            echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
            echo "see build results at        $WEBBASE_URL" ; \
            echo "including full build log at $WEBBASE_URL/log.txt" ; \
-            [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ) \
-           | sendmail $MAILTO
+            [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
+           [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
+           echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(pretty_duration $(($BUILD_END_S-$BUILD_BEG_S)))" ; \
+           ) | sendmail $MAILTO
     fi
     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
     # doesn't fix the problem, I'll remove it -- Sapan.
@@ -215,6 +232,12 @@ function success () {
     exit 0
 }
 
+##############################
+# manage root / container contexts
+function in_root_context () {
+    rpm -q libvirt > /dev/null 
+}
+
 # run in the vm - do not manage success/failure, will be done from the root ctx
 function build () {
     set -x
@@ -289,7 +312,7 @@ function run_log () {
     ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
 
     # check it out in the build
-    lxcsu -ro $BASE make -C /build tests-module
+    virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "make -C /build tests-module"
     
     # push it onto the testmaster - just the 'system' subdir is enough
     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
@@ -299,11 +322,19 @@ function run_log () {
     # invoke test on testbox - pass url and build url - so the tests can use vtest-init-lxc.sh
     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
 
-    # need to proceed despite of set -e
-    success=true
-    # passing the build_scm_url should not be needed anymore
-    ssh 2>&1 -n ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all || success=
+    # temporarily turn off set -e
+    set +e
+    ssh 2>&1 ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
+
+    # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
+    echo "retcod from run_log" $retcod
+    case $retcod in
+       0) success=true; IGNORED="" ;;
+       2) success=true; IGNORED=true ;;
+       *) success="";   IGNORED="" ;; 
+    esac
 
+    set -e
     # gather logs in the build vm
     mkdir -p $(rootdir $BASE)/build/testlogs
     rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ $(rootdir $BASE)/build/testlogs
@@ -320,10 +351,6 @@ function run_log () {
     
 }
 
-function in_root_context () {
-    rpm -q libvirt > /dev/null 
-}
-
 # this part won't work if WEBHOST does not match the local host
 # would need to be made webpublish_* compliant
 # but do we really need this feature anyway ?
@@ -438,6 +465,7 @@ function usage () {
     echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
     echo " -y {pl,pg} - passed to run_log"
     echo " -e step - passed to run_log"
+    echo " -i step - passed to run_log"
     echo " -X : passes --lxc to run_log"
     echo " -S : passes --vs to run_log"
     echo " -x <run_log_args> - a hook to pass other arguments to run_log"
@@ -455,7 +483,6 @@ function usage () {
     echo " -n - dry-run: -n passed to make - vm gets created though - no mail sent"
     echo " -v - be verbose"
     echo " -7 - uses weekday-@FCDISTRO@ as base"
-    echo " -i ifname - defaults to $DEFAULT_IFNAME - used to determine local IP"
     echo " --build-branch branch - build using the branch from build module"
     exit 1
 }
@@ -475,7 +502,7 @@ function main () {
     SIGNYUMREPO=""
 
     OPTS_ORIG=$@
-    OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
+    OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:i:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
     if [ $? != 0 ]
     then
         usage
@@ -497,6 +524,7 @@ function main () {
            -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --rspec-style $2"; shift 2 ;;
            # -e foo -> run_log -e foo
            -e) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --exclude $2"; shift 2 ;;
+           -i) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --ignore $2"; shift 2 ;;
            # -X -> run_log --lxc
            -X) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --lxc"; shift;;
            # -S -> run_log --vs
@@ -519,7 +547,6 @@ function main () {
            -n) DRY_RUN="-n" ; shift ;;
            -v) set -x ; VERBOSE="-v" ; shift ;;
            -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
-           -i) IFNAME=$2; shift 2 ;;
            -P) PREINSTALLED="-P $2"; shift 2;;
            -h) usage ; shift ;;
             --) shift; break ;;
@@ -551,7 +578,6 @@ function main () {
     [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
     [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
     [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
-    [ -z "$IFNAME" ] && IFNAME="$DEFAULT_IFNAME"
     [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
@@ -619,19 +645,19 @@ function main () {
            set -x
            echo "XXXXXXXXXX $COMMAND: using existing vm $BASE" $(date)
            # start in case e.g. we just rebooted
-           virsh --connect lxc:/// start ${BASE} || :
+           virsh -c lxc:/// start ${BASE} || :
            # retrieve environment from the previous run
-           FCDISTRO=$(lxcsu -ro ${BASE} /build/getdistroname.sh)
-           BUILD_SCM_URL=$(lxcsu -ro ${BASE} make --no-print-directory -C /build stage1=skip +build-GITPATH)
+           FCDISTRO=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/getdistroname.sh)
+           BUILD_SCM_URL=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip +build-GITPATH")
            # for efficiency, crop everything in one make run
            tmp=/tmp/${BASE}-env.sh
-           lxcsu -ro ${BASE} make --no-print-directory -C /build stage1=skip \
-               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT > $tmp
+           virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip \
+               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
            . $tmp
            rm -f $tmp
            # update build
            [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           lxcsu -ro $BASE bash -c "cd /build; git pull; make tests-clean"
+           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "cd /build; git pull; make tests-clean"
            # make sure we refresh the tests place in case it has changed
            rm -f /build/MODULES/tests
            options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
@@ -672,13 +698,14 @@ function main () {
 
             # Create lxc vm
            cd $tmpdir
-           ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} -i ${IFNAME} ${PREINSTALLED} ${BASE} 
+           ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE} 
            # cleanup
            cd -
            rm -rf $tmpdir
            # Extract build again - in the vm
            [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           lxcsu -ro $BASE bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
+           # xxx not working as of now - waiting for Sapan to look into this
+           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
        fi
        echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
 
@@ -710,8 +737,8 @@ function main () {
            cp $COMMANDPATH $(rootdir ${BASE})/build/
 
            # invoke this command in the vm for building (-T)
-           lxcsu -ro ${BASE} chmod +x /build/$COMMAND
-           lxcsu -ro ${BASE} /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
+           virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "chmod +x /build/$COMMAND"
+           virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
        fi
 
        # publish to the web so run_log can find them
@@ -725,7 +752,7 @@ function main () {
        else
            # run scanpackages so we can use apt-get on this
            # (not needed on fedora b/c this is done by the regular build already)
-           lxcsu -ro $BASE bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
+           virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
            webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
            webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb 
            webpublish_rsync_files $WEBPATH/$BASE/ $(rootdir $BASE)/build/Packages.gz
@@ -757,7 +784,7 @@ function main () {
         echo "==================== MAIN END $(date)"   
     fi
 
-}  
+}
 
 ##########
 main "$@"